require 'drb'
require 'borges/Utilities'

DRb.start_service

module Borges

##
# Namespace for Apache+DRb Client Utilities.

module ApacheDRbClient

  ##
  # Pass this request off to the DRb Server

  def self.handle_with(server_uri)
    ar = Apache.request

    # append POST args to GET args (if any)
    args = ''
    get_args = ar.args
    post_args = ar.read

    if get_args and post_args then
      args = "#{get_args}&#{post_args}"

    elsif get_args.nil? then
      args = post_args

    elsif post_args.nil? then
      args = get_args

    end

    req = Request.new(ar.uri, args)

    res = DRbObject.new(nil, server_uri).handle_request(req)

    ar.content_type = res.contentType
    ar.status = res.status
    ar.send_http_header
    exit(ar.status) if ar.header_only?

    puts res.body
  end

end # module ApacheDRbClient

end # module Borges

