require 'webrick'

module Borges

class WebrickConnection < WEBrick::HTTPServlet::AbstractServlet

  def do_GET(req, res)
    request = Request.new(req.path, req.query)
    response = Response.new
    Application.handle_request(request, response)
    res.status = response.status
    res.body = response.body
    res["Content-type"] = response.contentType
  end

  def do_POST(request, response)
    do_GET(request, response)
  end
  
  def self.start(args = {})
    port = args[:Port] || 7000
    root = args[:Root] || "/"

    Borges.base_url = root

    server = WEBrick::HTTPServer.new(:Port => port)
    server.mount(root, self)

    trap("INT") {server.shutdown}
    server.start
  end
end

end

